
#include "def_vst.h"

#define MAX_LINE 4096

MAIN
{
    float f;
    char  line[MAX_LINE],
          sepstr[] = " \t\n",
          *pos;
    long  lc=0;
    bool  Nopt;

    static char *synopsis = "\
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n\
                                     V1.1, 3.10.1992,  V.Strom \n\
                                                               \n\
 usage: atof  < data  > f4_sig                                 \n\
                                                               \n\
 data       ASCII file, containing white space separated       \n\
            numbers in in one or more lines                    \n\
 f4_sig     binary floats                                      \n\
                                                               \n\
 atof converts numbers in ASCII representation into binary     \n\
 floats.                                                       \n\
                                                               \n\
 Options:                                                      \n\
 -N   discard the first field.                                 \n\
                                                               \n\
 See also ftoa, atoi, itoa.                                    \n\
                                                               \n\
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n";
    ARGS(0,"N","");
    BOPT('N',Nopt);

    while(fgets(line, MAX_LINE, stdin))
    {   lc++;
        if(strchr(line, '\n')==NULL)
            ERROR2("max. line length %d exceeded in \"%s\"", 
                   MAX_LINE, line);
        pos = strtok(line, sepstr);
        if(pos == NULL)
        {   DMESSAGE1("line %d empty",lc);
            continue; /*<<<<<<<<<<<<<<<<<<< CONTIUNE while <<<<<*/
        }
        if(Nopt)
            pos = strtok(NULL, sepstr);
        do
        {   if(sscanf(pos, "%f", &f)!=1)
                ERROR2("\"%s\" in line %d is not a float", pos, lc);
            FWRITE(&f,float,1,stdout);
            pos = strtok(NULL, sepstr);

        } while (pos != NULL);
    }

    return 0;
}   

